const bmbextPrefObserver =
{		
	get CI()
	{
		return Components.interfaces;
	},
	set Ci(){},	// make it kind of a constant ;-)
	_branch: null,
	_registered: false,
	register: function(aPrefRoot)
	{
		if (this._registered)
		{
			dump("bmbextPrefObserver: can't register observer. observer already registered!\n");
			return;
		}
		
		const prefBranch = (typeof(this.CI.nsIPrefBranch2) == "object")?"nsIPrefBranch2":"nsIPrefBranchInternal";
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(this.CI.nsIPrefService);
		
		this._branch = prefService.getBranch(aPrefRoot);
		this._branch.QueryInterface(eval("this.CI."+prefBranch));
		this._branch.addObserver("", this, false);
		this._registered = true;
	},
	
	unregister: function()
	{
		if (!this._registered)
		{
			dump("bmbextPrefObserver: can't unregister observer. observer not registered!\n");
			return;
		}
		
		this._branch.removeObserver("", this);
		this._registered = false;
	},
	
	QueryInterface: function(aIID)
	{
		if (!aIID.equals(this.CI.nsISupports) && !aIID.equals(this.CI.nsIObserver))
		{
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	
	observe: function(aSubject, aTopic, aData)
	{
		if (aTopic != "nsPref:changed")
		{
			return;
		}
		
		var component = 0;
		if (aData.search(/^History\./) == 0)
		{
			component = 1;
		}
		else if (aData.search(/^Sort\./) == 0)
		{
			component = 2;
		}
		
		switch(component)
		{
			case 0:
				this.handleBMB(aData);
				break;
			
			case 1:
				this.handleHMB(aData);
				break;
			
			case 2:
				this.handleSort(aData);
				break;
		}
	},
	
	handleBMB: function(aData)
	{
		if (typeof(bmbext) == "undefined")
		{
			dump("bmbextPrefObserver: bmbext is undefined!\n");
			return;
		}
		
		switch(aData)
		{
			case "bookmarkmenu.hide":
			case "settings.MiddleClickOpens":
			case "settings.RightClickOpens":
				bmbext.loadPrefs();
				bmbext.showHide();
				break;
			
			case "dropmarker.hide":
				bmbext.loadPrefs();
				bmbext.showHideDropmarker();
				break;
			
			case "settings.hide":
				bmbext.loadPrefs();
				break;
			
			default:
				break;
		}
	},
	
	handleHMB: function(aData)
	{
		if (typeof(bmbextHistory) == "undefined")
		{
			dump("bmbextPrefObserver: bmbextHistory is undefined!\n");
			return;
		}
		
		bmbextHistory.loadPrefs();
		switch(aData)
		{
			case "History.gomenu.hide":
				bmbextHistory.hideGoMenu();
				break;
			
			case "History.dropmarker.hide":
				bmbextHistory.showHideDropmarker();
				break;
			
			default:
				break;
		}
	},
	
	handleSort: function(aData)
	{
		if (typeof(bmbextSort) == "undefined")
		{
			dump("bmbextPrefObserver: bmbextSort is undefined!\n");
			return;
		}
		
		bmbextSort.loadPrefs();
	}
}
