/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Bookmarks Menu Button.
 *
 * The Initial Developer of the Original Code is Ronny Perinke.
 * Portions created by the Initial Developer are Copyright (C) 2004-2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *   Ronny Perinke <www.sephiroth-j.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
 /*
#########################
#		new sorting stuff		#
#########################
*/

var bmbextSort = {
 	//#######################################
	//########	private functions and properties	########
	//########						########
	//#######################################
	_Prefs:
	{
		sortrecursive: true,				// include subfolders?
		excludetoolbar: true,				// do not sort the bookmarks toolbar?
		alphabetic: 1,					// 1==ABC-style; -1==ZYX-style
		sortcriterion: 1,					// 1==name; 2==last visit; 3==URL
		sortfolderstyle: 1,				// 1==folders on top; 2==mixed; 3==above
		showextrasortmenu: false			// display full (old) sort menu?
	},
	_MiscVars:
	{
		selection: null,
		PrefsIFace: null,					// refers to the nsIPref interface
		StringBundle: null				// holds the stringbundleset
	},
	get prefRoot()
	{
		return "BMBExt.Sort.";
	},
	set prefRoot(aString){},
	get StringBundle()
	{
		if (!this._MiscVars.StringBundle)
		{
			this.StringBundle = "";
		}
		return this._MiscVars.StringBundle;
	},
	set StringBundle()
	{
		this._MiscVars.StringBundle = document.getElementById("bmbextstr");
	},
	get PrefsIFace()
	{
		if (!this._MiscVars.PrefsIFace)
		{
			this.PrefsIFace = this.prefRoot;
		}
		return this._MiscVars.PrefsIFace;
	},
	set PrefsIFace(aBranch)
	{
		if (typeof(aBranch) != "string")
		{
			throw Components.results.NS_ERROR_ILLEGAL_VALUE + "\nValue must be a string type";
		}
		
		this._MiscVars.PrefsIFace = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
		this._MiscVars.PrefsIFace = this._MiscVars.PrefsIFace.getBranch((aBranch != "")?aBranch:this.prefRoot);
	},
	get selection()
	{
		return this._MiscVars.selection;
	},
	set selection(aObject)
	{
		this._MiscVars.selection = aObject;
	},
	//#######################################
	//########	/private functions and properties	########
	//########						########
	//#######################################
	
	init: function()
	{
		bmbextSort.loadPrefs();
		bmbextSort.changeSortCmds();
	},
	
	loadPrefs: function()
	{	
		// load user settings
		this.PrefsIFace = this.prefRoot;
		
		this._Prefs.sortrecursive= this.PrefsIFace.getBoolPref("settings.sortrecursive");
		this._Prefs.excludetoolbar= this.PrefsIFace.getBoolPref("settings.excludetoolbar");	// hm, wird glaub ich eh nicht gemacht -.-
		this._Prefs.sortfolderstyle= this.PrefsIFace.getIntPref("settings.sortfolderstyle");
		this._Prefs.alphabetic= this.PrefsIFace.getIntPref("settings.alphabetic");
		this._Prefs.sortcriterion= this.PrefsIFace.getIntPref("settings.sortcriterion");
		this._Prefs.showextrasortmenu= this.PrefsIFace.getBoolPref("settings.showextrasortmenu");
	},
	
	changeSortCmds: function()
	{
		// prevents conflicts with the menupop of my sort menupopup
		eval('BookmarksMenu.createContextMenu='+BookmarksMenu.createContextMenu.toString().replace(
			"BookmarksCommand.createContextMenu(aEvent, this._selection, this._db);",
			"if (aEvent.target.id == 'bookmarks-context-menu') \
				BookmarksCommand.createContextMenu(aEvent, this._selection, this._db);")
		);
		eval('BookmarksMenu.destroyContextMenu='+BookmarksMenu.destroyContextMenu.toString().replace(
			"if (content)",
			"if (aEvent.target.id != 'bookmarks-context-menu') \
				return; \
				 \
			if (content)")
		);
		// replace orig. sort menuitem with my sortmenu
		eval('BookmarksCommand.createMenuItem='+BookmarksCommand.createMenuItem.toString().replace(
			"return xulElement;",
			"if (aCommandName == 'http://home.netscape.com/NC-rdf#command?cmd=bm_sortbyname') \
				xulElement = bmbextSort.createDirectSortMenuentry(); \
			return xulElement;")
		);
		// add support for additional sort menu
		var contextmenu = document.getElementById("bookmarks-context-menu");
		contextmenu.addEventListener("popupshowing", bmbextSort.addExtraContextMenu, false);
	},
	
	addExtraContextMenu: function(aEvent)
	{
		if (aEvent.target.id != 'bookmarks-context-menu')
		{
			return;
		}
		
		var target = document.popupNode;
		bmbextSort.selection = BookmarksMenu.getBTSelection(target);
		
		if (bmbextSort._Prefs.showextrasortmenu)
		{
			var contextmenu = document.getElementById("bookmarks-context-menu");
			var sortnowitem = document.getElementById("bmbext-SortNow");
			var sortmenu = bmbextSort.createSortMenu();
			contextmenu.insertBefore(sortmenu, sortnowitem.nextSibling);
		}
	},
	
	SortByWhatever: function (aSortType, aSortDir)
	{
		var aSelection = this.selection;
		var SortRecursive = this._Prefs.sortrecursive;
		var SortExcludePersonalToolbar = this._Prefs.excludetoolbar;
		setTimeout(bmbextSort.realSortByWhatever, 1, aSelection, aSortType, aSortDir, SortRecursive, SortExcludePersonalToolbar);
	},
	SortNowByWhatever: function ()
	{
		var aSelection = this.selection;
		var SortType = "";
		var SortDir = 1;
		
		var SortRecursive = this._Prefs.sortrecursive;
		var SortExcludePersonalToolbar = this._Prefs.excludetoolbar;
		
		switch(this._Prefs.sortcriterion)
		{
			case 1:
				SortType = "Name";
				break;
			case 2:
				SortType = "LastVisit";
				break;
			case 3:
				SortType = "URL";
				break;
			default:
				SortType = "Name";
				break;
		}
		SortDir = this._Prefs.alphabetic * this._Prefs.sortfolderstyle;
		
		setTimeout(bmbextSort.realSortByWhatever, 1, aSelection, SortType, SortDir, SortRecursive, SortExcludePersonalToolbar);
	},
	realSortByWhatever: function (aSelection, aSortType, aSortDir, SortRecursive, SortExcludePersonalToolbar)
	{
		var RDFC = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
		var RDFS = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var BMDS  = RDFS.GetDataSource("rdf:bookmarks");
		var theFolder;
		if (aSelection.length != 1)
		{
			return;
		}
		
		var selType = BookmarksUtils.resolveType(aSelection.item[0]);
		if (selType == "Folder" || selType == "Bookmark" || (selType == "PersonalToolbarFolder" && !SortExcludePersonalToolbar) || selType == "Livemark")
		{
			theFolder = aSelection.parent[0];
		}
		else
		{
			// we're not going to try to sort ImmutableBookmark siblings or any other such things, since it'll probably just get us into trouble
			return;
		}
		selType = BookmarksUtils.resolveType(theFolder);
		if (selType == "PersonalToolbarFolder" && SortExcludePersonalToolbar)
		{
			return;	// exclude personal toolbar folder
		}
		
		var toSort = [];
		RDFC.Init(BMDS, theFolder);
		var folderContents = RDFC.GetElements();
		
		// fill the array with the elements to sort to
		while (folderContents.hasMoreElements())
		{
			var rsrc = folderContents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
			var rtype = BookmarksUtils.resolveType(rsrc);
			if (rtype == "BookmarkSeparator")
			{
				continue;
			}
			else if (SortRecursive && (rtype == "Folder"||(rtype == "PersonalToolbarFolder" && !SortExcludePersonalToolbar)))
			{		
				// call realSortByWhatever with the folder as selection
				var newSelection = {};
				newSelection.item = [rsrc];
				newSelection.parent = [rsrc];
				newSelection.isExpanded = [false];
				newSelection.length = newSelection.item.length;
				bmbextSort.realSortByWhatever(newSelection, aSortType, aSortDir, SortRecursive, SortExcludePersonalToolbar);
			}
			toSort.push(rsrc);
		}
		
		if (!aSortType)
		{
			aSortType = "Name";
		}
		
		if (!aSortDir)
		{
			aSortDir = 1;
		}
		
		var kRes, kIFace;
		switch(aSortType)
		{
			case "Name":
			case "URL":
				kRes = RDFS.GetResource("http://home.netscape.com/NC-rdf#"+aSortType);
				kIFace = Components.interfaces.nsIRDFLiteral;
				break;
			case "LastVisit":
				kRes = RDFS.GetResource("http://home.netscape.com/WEB-rdf#LastVisitDate");
				kIFace = Components.interfaces.nsIRDFDate
				break;
			default:
				kRes = RDFS.GetResource("http://home.netscape.com/NC-rdf#Name");
				kIFace = Components.interfaces.nsIRDFLiteral;
				break;
		}
		var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
		var collationFactory = Components.classes["@mozilla.org/intl/collation-factory;1"].getService(Components.interfaces.nsICollationFactory);
		var collation = collationFactory.CreateCollation(localeService.getApplicationLocale());
		
		// custom sort method for the  array of bookmarks nad folders to sort to
		function ArraySort(a, b)
		{
			var atype = BookmarksUtils.resolveType(a);
			var btype = BookmarksUtils.resolveType(b);
			var aisfolder = (atype == "Folder") || (atype == "PersonalToolbarFolder");
			var bisfolder = (btype == "Folder") || (btype == "PersonalToolbarFolder");
			
			// sort folders
			switch(Math.abs(aSortDir))
			{
				case 1:					//place folders above bookmarks
					if (aisfolder && !bisfolder)
						return -1;
					if (bisfolder && !aisfolder)
						return 1;
					break;
					
				case 2:					//mix folders and bookmarks for sortbyname and sortbylastvisit
					break;
					
				case 3:					//place folders below bookmarks
					if (aisfolder && !bisfolder)
						return 1;
					if (bisfolder && !aisfolder)
						return -1;
					break;
					
				default:					//place folders above bookmarks by default
					if (aisfolder && !bisfolder)
						return -1;
					if (bisfolder && !aisfolder)
						return 1;
					break;
			}
			
			var aname = BMDS.GetTarget(a, kRes, true);
			if (aname)
			{
				aname = aname.QueryInterface(kIFace).Value;
			}
			var bname = BMDS.GetTarget(b, kRes, true);
			if (bname)
			{
				bname = bname.QueryInterface(kIFace).Value;
			}
			
			// sort the bookmarks
			if (aSortType == "LastVisit")
			{
				if (aname == bname)
				{
					return 0;
				}
				else
				{
					if (aname > bname)
					{
						return (aSortDir >= 0) ? -1 : 1;
					}
					else
					{
						return (aSortDir >= 0) ? 1 : -1;
					}
				}
			}
			else
			{	
				if (aSortDir >= 0)
				{
					return collation.compareString(0, aname, bname);	//sort in alphabetical order
				}
				else
				{
					return collation.compareString(0, bname, aname);	//sort in reverse alphabetical order
				}
			}
		}
		// sort the  array with a custom sort function
		toSort.sort(ArraySort);
		
		// we now have the resources here sorted
		BMDS.beginUpdateBatch();
		RDFC.Init(BMDS, theFolder);
		
		// remove existing elements
		folderContents = RDFC.GetElements();
		while (folderContents.hasMoreElements())
		{
			RDFC.RemoveElement(folderContents.getNext(), false);
		}
		
		// and add our elements back
		for (var i = 0, l=toSort.length; i < l; i++)
		{
			RDFC.InsertElementAt(toSort[i], i+1, true);
		}
		
		BMDS.endUpdateBatch();
	},
	
	createSortMenu: function()
	{
		var xulElement1 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menu");
		xulElement1.id = "bmbext-SortMenu";
		xulElement1.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort"));
		var xulElement2 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menupopup");
		xulElement2.id="bmbext-SortMenuPopup";
		
		// sort by name descending menu
		var xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menu");
		xulElement3.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.ABC"));
		var xulElement4 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menupopup");
		xulElement4.id="bmbext-SortMenuInnerPopup1";
		var xulElement5 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement5.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersFirst"));
		xulElement5.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',1);");
		var xulElement6 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement6.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersMixed"));
		xulElement6.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',2);");
		var xulElement7 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement7.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersLast"));
		xulElement7.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',3);");
		xulElement4.appendChild(xulElement5);
		xulElement4.appendChild(xulElement6);
		xulElement4.appendChild(xulElement7);
		xulElement3.appendChild(xulElement4);
		xulElement2.appendChild(xulElement3);
		
		// sort by name ascending menu
		xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menu");
		xulElement3.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.ZYX"));
		xulElement4 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menupopup");
		xulElement4.id="bmbext-SortMenuInnerPopup2";
		xulElement5 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement5.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersFirst"));
		xulElement5.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',-1);");
		xulElement6 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement6.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersMixed"));
		xulElement6.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',-2);");
		xulElement7 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement7.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.FoldersLast"));
		xulElement7.setAttribute("oncommand", "bmbextSort.SortByWhatever('Name',-3);");
		xulElement4.appendChild(xulElement5);
		xulElement4.appendChild(xulElement6);
		xulElement4.appendChild(xulElement7);
		xulElement3.appendChild(xulElement4);
		xulElement2.appendChild(xulElement3);
		
		// sort by last visit
		xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement3.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.LastVisit"));
		xulElement3.setAttribute("oncommand", "bmbextSort.SortByWhatever('LastVisit',2);");
		xulElement2.appendChild(xulElement3);
		
		// sort by URL
		xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement3.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.URL"));
		xulElement3.setAttribute("oncommand", "bmbextSort.SortByWhatever('URL',1);");
		xulElement2.appendChild(xulElement3);
		
		// sort-settings menuseparator
		xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuseparator");
		xulElement2.appendChild(xulElement3);
		// sort-settings itself
		xulElement3 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement3.setAttribute("label", this.StringBundle.getString("bmb-ext.Sort.SortSettingsItem"));
		xulElement3.setAttribute("oncommand", "bmbext.OpenSettings(2);");
		xulElement2.appendChild(xulElement3);
		
		// finally append the popup to the menu
		xulElement1.appendChild(xulElement2);
		return xulElement1;
	},
	createDirectSortMenuentry: function()
	{
		var xulElement1 = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		xulElement1.setAttribute("label", this.StringBundle.getString("bmb-ext.SortNow"));
		xulElement1.id = "bmbext-SortNow";
		xulElement1.setAttribute("oncommand", "bmbextSort.SortNowByWhatever();");
		return xulElement1;
	}
}
